#include <stdio.h>
#include <stdlib.h>

void qwrite(FILE *file)
{
  int buf[4096];
  int x=1;
  fseek(file, 0, SEEK_SET);
  while(x)
    {
      x=fread(buf, sizeof(int), 4096, file);
      if (x)
        x=fwrite(buf, sizeof(int), x, stdout);
    }
}

int main(int argc, char **argv)
{
  FILE *pri, *sec;
  int p_size, s_size;
  if (argc<4)
    {
      fprintf(stderr, "Need more params\n");
      exit(1);
    }
  sec=fopen(argv[3], "r");
  if (atoi(argv[1])!=0)
    {
      fprintf(stderr, "Using backup\n");
      qwrite(sec);
      exit (0);
    }
  pri=fopen(argv[2], "r");
  fseek(pri, 0, SEEK_END);
  fseek(sec, 0, SEEK_END);
  p_size=ftell(pri);
  s_size=ftell(sec);
  fprintf(stderr, "Original: %d bytes\n", s_size);
  fprintf(stderr, "Optimized: %d bytes\n", p_size);
  if (s_size<p_size)
    qwrite(sec);
  else
    qwrite(pri);
  return 0;
}
